<?php
/**
 * Construction Engineer functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package construction_engineer
 */

$construction_engineer_theme_data = wp_get_theme();
if( ! defined( 'CONSTRUCTION_ENGINEER_THEME_VERSION' ) ) define ( 'CONSTRUCTION_ENGINEER_THEME_VERSION', $construction_engineer_theme_data->get( 'Version' ) );
if( ! defined( 'CONSTRUCTION_ENGINEER_THEME_NAME' ) ) define( 'CONSTRUCTION_ENGINEER_THEME_NAME', $construction_engineer_theme_data->get( 'Name' ) );
if( ! defined( 'CONSTRUCTION_ENGINEER_THEME_TEXTDOMAIN' ) ) define( 'CONSTRUCTION_ENGINEER_THEME_TEXTDOMAIN', $construction_engineer_theme_data->get( 'TextDomain' ) );

if ( ! defined( 'CONSTRUCTION_ENGINEER_VERSION' ) ) {
	define( 'CONSTRUCTION_ENGINEER_VERSION', '1.0.0' );
}

if ( ! function_exists( 'construction_engineer_setup' ) ) :
	
	function construction_engineer_setup() {
		
		load_theme_textdomain( 'construction-engineer', get_template_directory() . '/languages' );

		add_theme_support( 'woocommerce' );

		add_theme_support( 'automatic-feed-links' );
		
		add_theme_support( 'title-tag' );

		add_theme_support( 'post-thumbnails' );

		register_nav_menus(
			array(
				'primary' => esc_html__( 'Primary', 'construction-engineer' ),
			)
		);

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'style',
				'script',
				'woocommerce',
			)
		);

		add_theme_support( 'post-formats', array(
			'image',
			'video',
			'gallery',
			'audio', 
		) );

		add_theme_support(
			'custom-background',
			apply_filters(
				'construction_engineer_custom_background_args',
				array(
					'default-color' => 'ffffff',
					'default-image' => '',
				)
			)
		);

		add_theme_support( 'customize-selective-refresh-widgets' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 250,
				'width'       => 250,
				'flex-width'  => true,
				'flex-height' => true,
			)
		);

		add_theme_support( 'align-wide' );

		add_theme_support( 'responsive-embeds' );
	}
endif;
add_action( 'after_setup_theme', 'construction_engineer_setup' );

function construction_engineer_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'construction_engineer_content_width', 640 );
}
add_action( 'after_setup_theme', 'construction_engineer_content_width', 0 );

function construction_engineer_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'construction-engineer' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'construction-engineer' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title"><span>',
			'after_title'   => '</span></h2>',
		)
	);

	// Regsiter 4 footer widgets.
	// Regsiter 4 footer widgets.
	$construction_engineer_footer_widget_column = get_theme_mod('construction_engineer_footer_widget_column','4');
	for ($i=1; $i<=$construction_engineer_footer_widget_column; $i++) {
		register_sidebar( array(
			'name' => __( 'Footer  ', 'construction-engineer' )  . $i,
			'id' => 'construction-engineer-footer-widget-' . $i,
			'description' => __( 'The Footer Widget Area', 'construction-engineer' )  . $i,
			'before_widget' => '<aside id="%1$s" class="widget %2$s">',
			'after_widget' => '</aside>',
			'before_title' => '<div class="widget-header"><h4 class="widget-title">',
			'after_title' => '</h4></div>',
		) );
	}
}
add_action( 'widgets_init', 'construction_engineer_widgets_init' );

/**
 * Enqueue scripts and styles.
 */
function construction_engineer_scripts() {
	// Append .min if SCRIPT_DEBUG is false.
	$min = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';

	// Slick style.
	wp_enqueue_style( 'construction-engineer-slick-style', get_template_directory_uri() . '/resource/css/slick' . $min . '.css', array(), '1.8.1' );

	// Fontawesome style.
	wp_enqueue_style( 'font-awesome-css', esc_url(get_template_directory_uri())."/resource/css/fontawesome-all.css" );

	// Main style.
	wp_enqueue_style( 'construction-engineer-style', get_template_directory_uri() . '/style.css', array(), CONSTRUCTION_ENGINEER_VERSION );

	// RTL style.
	wp_style_add_data('construction-engineer-style', 'rtl', 'replace');

	if (get_theme_mod('construction_engineer_enable_animation', true) == true){
		// Animate CSS
		wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/resource/css/animate.css' );
		// Wow script.
		wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/resource/js/wow.js', array('jquery'),'' ,true );
	}

	// Navigation script.
	wp_enqueue_script( 'construction-engineer-navigation-script', get_template_directory_uri() . '/resource/js/navigation.js', array(), CONSTRUCTION_ENGINEER_VERSION, true );

	// Slick script.
	wp_enqueue_script( 'construction-engineer-slick-script', get_template_directory_uri() . '/resource/js/slick' . $min . '.js', array( 'jquery' ), '1.8.1', true );

	// Custom script.
	wp_enqueue_script( 'construction-engineer-custom-script', get_template_directory_uri() . '/resource/js/custom.js', array( 'jquery' ), CONSTRUCTION_ENGINEER_VERSION, true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	// Include the file.
	require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

	// Load the webfont.
	wp_enqueue_style(
		'tenor-sans',
		wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Tenor+Sans&display=swap' ),
		array(),
		'1.0'
	);

	wp_enqueue_style(
		'raleway',
		wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Raleway:ital,wght@0,100..900;1,100..900&display=swap' ),
		array(),
		'1.0'
	);

}
add_action( 'wp_enqueue_scripts', 'construction_engineer_scripts' );

//Change number of products per page 
add_filter( 'loop_shop_per_page', 'construction_engineer_products_per_page' );
function construction_engineer_products_per_page( $cols ) {
  	return  get_theme_mod( 'construction_engineer_products_per_page',9);
}

// Change number or products per row 
add_filter('loop_shop_columns', 'construction_engineer_loop_columns');
	if (!function_exists('construction_engineer_loop_columns')) {
	function construction_engineer_loop_columns() {
		return get_theme_mod( 'construction_engineer_products_per_row', 3 );
	}
}

/**
 * Include wptt webfont loader.
 */
require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/theme-library/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/theme-library/function-files/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/theme-library/function-files/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/theme-library/customizer.php';

/**
 * Google Fonts
 */
require get_template_directory() . '/theme-library/function-files/google-fonts.php';

/**
 * Dynamic CSS
 */
require get_template_directory() . '/theme-library/dynamic-css.php';


/**
 * Breadcrumb
 */
require get_template_directory() . '/theme-library/function-files/class-breadcrumb-trail.php';

/**
 * Getting Started
*/
require get_template_directory() . '/theme-library/getting-started/getting-started.php';

/**
 * Demo Import
*/
add_action( 'init', 'construction_engineer_load_theme_wizard' );
function construction_engineer_load_theme_wizard() {
    require get_parent_theme_file_path( '/theme-wizard/config.php' );
}

function construction_engineer_links_setup() {
	if ( ! defined( 'CONSTRUCTION_ENGINEER_PREMIUM_PAGE' ) ) {
	define('CONSTRUCTION_ENGINEER_PREMIUM_PAGE',__('https://asterthemes.com/products/engineer-wordpress-theme','construction-engineer'));
	}
	if ( ! defined( 'CONSTRUCTION_ENGINEER_THEME_PAGE' ) ) {
		define('CONSTRUCTION_ENGINEER_THEME_PAGE',__('https://asterthemes.com/products/construction-engineer','construction-engineer'));
	}
	if ( ! defined( 'CONSTRUCTION_ENGINEER_SUPPORT' ) ) {
	define('CONSTRUCTION_ENGINEER_SUPPORT',__('https://wordpress.org/support/theme/construction-engineer/','construction-engineer'));
	}
	if ( ! defined( 'CONSTRUCTION_ENGINEER_REVIEW' ) ) {
	define('CONSTRUCTION_ENGINEER_REVIEW',__('https://wordpress.org/support/theme/construction-engineer/reviews/','construction-engineer'));
	}
	if ( ! defined( 'CONSTRUCTION_ENGINEER_PRO_DEMO' ) ) {
	define('CONSTRUCTION_ENGINEER_PRO_DEMO',__('https://demo.asterthemes.com/construction-engineer/','construction-engineer'));
	}
	if ( ! defined( 'CONSTRUCTION_ENGINEER_THEME_DOCUMENTATION' ) ) {
	define('CONSTRUCTION_ENGINEER_THEME_DOCUMENTATION',__('https://demo.asterthemes.com/docs/construction-engineer-free/','construction-engineer'));
	}
	if ( ! defined( 'CONSTRUCTION_ENGINEER_PREMIUM_DOCUMENTATION' ) ) {
	define('CONSTRUCTION_ENGINEER_PREMIUM_DOCUMENTATION',__('https://demo.asterthemes.com/docs/construction-engineer-pro/','construction-engineer'));
	}
	if ( ! defined( 'CONSTRUCTION_ENGINEER_BUNDLE_PAGE' ) ) {
		define('CONSTRUCTION_ENGINEER_BUNDLE_PAGE',__('https://asterthemes.com/products/wp-theme-bundle','construction-engineer'));
	}
}
add_action('after_setup_theme', 'construction_engineer_links_setup');

/**
 * Customizer Settings Functions
*/
require get_template_directory() . '/theme-library/function-files/customizer-settings-functions.php';

// Enqueue Customizer live preview script
function construction_engineer_customizer_live_preview() {
    wp_enqueue_script(
        'construction-engineer-customizer',
        get_template_directory_uri() . '/resource/js/customizer.js',
        array('jquery', 'customize-preview'),
        '',
        true
    );
}
add_action('customize_preview_init', 'construction_engineer_customizer_live_preview');

// Featured Image Dimension
function construction_engineer_blog_post_featured_image_dimension(){
	if(get_theme_mod('construction_engineer_blog_post_featured_image_dimension') == 'custom' ) {
		return true;
	}
	return false;
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );


// Reset all theme settings
function construction_engineer_reset_demo_import_settings() {
    if (current_user_can('manage_options')) {
        // List only demo import-related settings to reset
		remove_theme_mod('construction_engineer_header_button_label_');
		remove_theme_mod('construction_engineer_header_button_link_');
		remove_theme_mod('construction_engineer_banner_button_label_');
		remove_theme_mod('construction_engineer_banner_button_link_');
		remove_theme_mod('construction_engineer_banner_second_button_label_');
		remove_theme_mod('construction_engineer_banner_second_button_link_');
		remove_theme_mod('construction_engineer_banner_short_heading_1');
		remove_theme_mod('construction_engineer_banner_short_heading_2');
		remove_theme_mod('construction_engineer_banner_short_heading_3');
		remove_theme_mod('construction_engineer_trending_product_heading');
		remove_theme_mod('construction_engineer_trending_product_content');

        wp_send_json_success(array('message' => __('Demo import settings have been reset.', 'construction-engineer')));
    } else {
        wp_send_json_error(array('message' => __('Permission denied.', 'construction-engineer')));
    }
}
add_action('wp_ajax_construction_engineer_reset_demo_import_settings', 'construction_engineer_reset_demo_import_settings'); 